﻿/**
 * rutor.org plugin for Movian Media Center
 *  Copyright (C) 2015 lprot
 *  You should have received a copy of the GNU General Public License
 *  along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
(function(plugin) {
    // <a\s+href="(\/(?:movies|tv)(?:\/genre\/\d+)?)"[^>]*>([^<]+)<


    //var reListWithIcons=/<div\s+class="preview vertical"><a\s+href="\/(movies|tv)\/(\d+)\/[\S\s]*? <div\s+class="info">\s*<p>Сидов:\s+(\d+)<[\S\s]*?<p>Личеров:\s*(\d+)<[\S\s]*?<p>Размер:\s*([^<]+)</g;
    // 1 type 2 id 3 title 4 seeders 5 leechers 6 size
    //

    //var reShort = /<tr\s*class="(?:lite|dark)">\s*<td[^>]+>[^<]+<[^>]*>\s*<td[^>]*><a\s+href="[^"]*?\/(tv|movies)\/(\d+)\/[^"]+">([^<]+)<[^>]*><[^>]*>\s*<td[^>]*><a\s+href="magnet:[^"]+">[\S\s]+?Magnet-ссылка"><[^>]*><[^>]*>\s*<td\s+[^>]*>([^<]+)<[^>]*>\s*<td[^>]*?color-green[^>]*>(\d+)<[^>]*>\s*<td[^>]*?color-red[^>]*>(\d+)</g 
    // 1 type 2 id 3 title 4 size 5 seed 6 leech

    //var rePage=/return=%2F(\w+)%2F(\d+)%2F[\S\s]+?class="title"><h1>([^<]+)<[\S\s]+?href="(magnet:[^"]+)"[\S\s]+?class="cell1">Размер:<\/td><td>([^<]+)<[\S\s]+?class="cell1">Начало\s+раздачи:<\/td><td>([^<]+)<[\S\s]+?Сидов:\s*<strong\s+class="color-green">(\d+)<[\S\s]+?Личеров:\s*<strong\s+class="color-red">(\d+)</g;
    // 1 type 2 id 3 name 4 magnet 5 size 6 date 7 seed 8 leech

    var logo = plugin.path + "logo.png";

    var blue = '6699CC',
        orange = 'FFA500',
        red = 'EE0000',
        green = '66ff72';

    function cleanStr(str) {
        return str.replace(/<[^>]+>/g, '').trim();
    }

    function colorStr(str, color) {
        return '<font color="' + color + '"> (' + str + ')</font>';
    }

    function coloredStr(str, color) {
        return '<font color="' + color + '">' + str + '</font>';
    }

    function setPageHeader(page, title) {
        if (page.metadata) {
            page.metadata.title = title;
            page.metadata.logo = logo;
        }
        page.type = "directory";
        page.contents = "items";
        page.loading = false;
    }

    var service = plugin.createService(plugin.getDescriptor().title, plugin.getDescriptor().id + ":start", "video", true, logo);

    var settings = plugin.createSettings(plugin.getDescriptor().title, logo, plugin.getDescriptor().synopsis);

    settings.createString('baseURL', "Base URL without '/' at the end.", 'http://megashara.com', function(v) {
        service.baseURL = v;
    });

    function listEx(page, doc, re, seeders, leechers, size) {
        var n =0;
        //1 type 2 id 3 title
        var match = re.exec(doc);
        while (match) {
            var url = '/' + match[1] + '/' + match[2];
            var licon = 'http://static.megashara.com/posters/th_1_'+match[2]+'.jpg';
            page.appendItem(plugin.getDescriptor().id + ':list:' + url, "directory", {
                title: new showtime.RichText(colorStr(match[1], orange) + ' ' + match[3] + ' ' + coloredStr(match[seeders], green) + '/' + coloredStr(match[leechers], red) + ' ' + colorStr(match[size], blue)),
                icon: licon
            });
            page.entries++;
            n++;
            match = re.exec(doc);
        }
        return n;
    }

    function list(page, doc) {
        var re1 = /<tr\s*class="(?:lite|dark)">\s*<td[^>]+>[^<]+<[^>]*>\s*<td[^>]*><a\s+href="[^"]*?\/(tv|movies)\/(\d+)\/[^"]+">([^<]+)<[^>]*><[^>]*>\s*<td[^>]*><a\s+href="magnet:[^"]+">[\S\s]+?Magnet-ссылка"><[^>]*><[^>]*>\s*<td\s+[^>]*>([^<]+)<[^>]*>\s*<td[^>]*?color-green[^>]*>(\d+)<[^>]*>\s*<td[^>]*?color-red[^>]*>(\d+)</g; 
        var re2 = /<div\s+class="preview vertical"><a\s+href="(?:[^"]*?)\/(movies|tv)\/(\d+)\/[\S\s]*?alt=\"([^"]+)\"[\s\S]+?<div\s+class="info">\s*<p>Сидов:\s+(\d+)<[\S\s]*?<p>Личеров:\s*(\d+)<[\S\s]*?<p>Размер:\s*([^<]+)</g;
        return listEx(page, doc, re1, 5, 6, 4) + listEx(page, doc, re2, 4, 5, 6);
    }



    function scraper(page, doc, id) {
        var rePage=/return=%2F(\w+)%2F(\d+)%2F[\S\s]+?class="title"><h1>([^<]+)<[\S\s]+?href="(magnet:[^"]+)"[\S\s]+?class="cell1">Размер:<\/td><td>([^<]+)<[\S\s]+?class="cell1">Начало\s+раздачи:<\/td><td>([^<]+)<[\S\s]+?Сидов:\s*<strong\s+class="color-green">(\d+)<[\S\s]+?Личеров:\s*<strong\s+class="color-red">(\d+)</g;
        // 1 type 2 id 3 name 4 magnet 5 size 6 date 7 seed 8 leech
        var m = rePage.exec(doc);
        page.metadata.glwview = plugin.path + "list.view";
        var obj = {
            downurl: m[4].split('&amp;').join('&'),
            downtext: '' + m[7] + ' / ' + m[8] + ' ('+ m[5] + ') ' + m[6],
            title: m[3],
            logo: 'http://static.megashara.com/posters/th_0_' + m[2] + '.jpg'
        } ;
         

        page.metadata.title = obj.title;
        page.metadata.logo = obj.logo;

        var arr = [
        	{u: /*'torrent:browse:' +*/ obj.downurl ,n:obj.downtext},
//        	{u:rx(/href="(magnet:[^"]+)"/,doc,1),n:'magnet'},
//        	{u:rx(/href="(magnet:[^"&]+)/,doc,1) + '&tr=udp%3A%2F%2Fopentor.org%3A2710&tr=http%3A%2F%2Fxbtrutor.com%3A2710%2Fannounce&tr=http%3A%2F%2Fbt.rutor.org%3A444%2Fannounce&tr=udp%3A//tracker.leechers-paradise.org%3A6969&tr=udp%3A//tracker.coppersurfer.tk%3A6969&tr=udp%3A//shubt.net%3A2710&tr=http%3A//p4p.arenabg.ch%3A1337/announcee&tr=udp%3A//tracker.opentrackr.org%3A1337&tr=udp%3A//explodie.org%3A6969&tr=udp%3A//tracker.zer0day.to%3A1337',n:'magnet'},
        ];

        for(var j=0; j<arr.length; j++){
            var url = arr[j].u;
            page.appendItem(url, "video", {
                title: arr[j].n,
                description: obj.title,
                icon: obj.logo
            });

            page.entries++;
        }
        list(page, doc);
    }

    function listPage(page, url, title) {
        setPageHeader(page, title);
        page.entries = 0;
        var fromPage = 0,
            tryToSearch = true;

        var loader = function(){
            if (!tryToSearch) return false;
            page.loading = true;
            var doc = showtime.httpReq(service.baseURL + url + fromPage ).toString();
            page.loading = false;
            var n = list(page, doc);
            if (n==0) return tryToSearch = false;
            fromPage++;
            return true;
        };

        loader();
        page.paginator = loader;
    }



    plugin.addURI(plugin.getDescriptor().id + ":category:(.*):(.*)", function(page, url, name) {
        setPageHeader(page, plugin.getDescriptor().synopsis);
        name = decodeURIComponent(name);
        var re = /\/(movies|tv)\/genre\/(\d+)/g;
        var m = re.exec(url);
        if(m){
            url = '/' + m[1] + '/?genre=' + m[2] + '&year=0&quality=&sorting=&order=&page=';
        } else {
            url = url + '/?genre=0&year=0&quality=&sorting=&order=&page=';
        }
        listPage(page, url, name)
    });

    plugin.addURI(plugin.getDescriptor().id + ":list:(.*)", function(page, url) {
        setPageHeader(page, plugin.getDescriptor().synopsis);
        page.loading = true;
        var url1 = service.baseURL + url + '/nwn3s8zn.html';
        var doc = showtime.httpReq(url1).toString();
        scraper(page, doc, url);
        page.loading = false;
    });

    function fillStart(page,doc){
        list(page,doc);
        page.appendItem("", "separator", {title: ''});

        var arrow = plugin.path + "arrow.png";

        var re = /<a\s+href="(\/(?:movies|tv)(?:\/genre\/\d+)?)"[^>]*>([^<]+)</g;
        var match = re.exec(doc);
        while (match) {
            if(match[2]!=='Далее') {
                page.appendItem(plugin.getDescriptor().id + ":category:" + match[1] + ':' + encodeURIComponent(match[2]), 
                    "directory", 
                    {
                        title: match[2],
                        icon: arrow
                    }
                );
            }
            match = re.exec(doc);
        }
    }

    plugin.addURI(plugin.getDescriptor().id + ":start", function(page) {
        setPageHeader(page, plugin.getDescriptor().synopsis);
        page.loading = true;
        var url1 = service.baseURL + '/';
        var doc = showtime.httpReq(url1).toString();
        fillStart(page, doc);
        page.loading = false;
    });
})(this);